/*
 * #%L
 * Reef DB :: Core
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2014 - 2015 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */
//
/**
 * @author Generated on 12/09/2016 10:12:00+0100 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige2.core::vo::administration::strategy::StrategyVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige2.core.vo.administration.strategy;

import fr.ifremer.quadrige2.core.vo.administration.program.ProgramVO;
import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.Date;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Définie les paramètres à mesurer dans un programme particulier.
 */
public class StrategyVO
    implements Serializable, Comparable<StrategyVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = -689132129716129621L;

    // Class attributes
    /**
     * Identifiant interne de la stratégie
     */
    protected Integer stratId;
    /**
     * Libellé de la stratégie
     */
    protected String stratNm;
    /**
     * Description de la stratégie (de type commentaire car taille insuffisante)
     */
    protected String stratDc;
    /**
     * Date de création de l'objet
     */
    protected Date stratCreationDt;
    /**
     * Date de mise à jour de l'objet
     */
    protected Timestamp updateDt;
    /** TODO: Model Documentation for attribute statusCd */
    protected String statusCd;
    /** TODO: Model Documentation for attribute progCd */
    protected String progCd;
    /** TODO: Model Documentation for attribute respDepIds */
    protected Integer[] respDepIds;
    /** TODO: Model Documentation for attribute respQuserIds */
    protected Integer[] respQuserIds;

    // Class associationEnds
    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     */
    protected ProgramVO programVO;

    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     */
    protected AppliedStrategyVO[] appliedStrategyVOs;

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     */
    protected PmfmStrategyVO[] pmfmStrategyVOs;

    /** Default Constructor with no properties */
    public StrategyVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param stratIdIn Integer Identifiant interne de la stratégie
     * @param stratNmIn String Libellé de la stratégie
     * @param statusCdIn String
     * @param progCdIn String
     * @param respDepIdsIn Integer[]
     * @param respQuserIdsIn Integer[]
     * @param programVOIn ProgramVO Activités à l'origine de la collecte d'un ensemble cohérent de données.
     */
    public StrategyVO(final Integer stratIdIn, final String stratNmIn, final String statusCdIn, final String progCdIn, final Integer[] respDepIdsIn, final Integer[] respQuserIdsIn, final ProgramVO programVOIn)
    {
        this.stratId = stratIdIn;
        this.stratNm = stratNmIn;
        this.statusCd = statusCdIn;
        this.progCd = progCdIn;
        this.respDepIds = respDepIdsIn;
        this.respQuserIds = respQuserIdsIn;
        this.programVO = programVOIn;
    }

    /**
     * Constructor with all properties
     * @param stratIdIn Integer
     * @param stratNmIn String
     * @param stratDcIn String
     * @param stratCreationDtIn Date
     * @param updateDtIn Timestamp
     * @param statusCdIn String
     * @param progCdIn String
     * @param respDepIdsIn Integer[]
     * @param respQuserIdsIn Integer[]
     * @param programVOIn ProgramVO
     * @param appliedStrategyVOsIn AppliedStrategyVO[]
     * @param pmfmStrategyVOsIn PmfmStrategyVO[]
     */
    public StrategyVO(final Integer stratIdIn, final String stratNmIn, final String stratDcIn, final Date stratCreationDtIn, final Timestamp updateDtIn, final String statusCdIn, final String progCdIn, final Integer[] respDepIdsIn, final Integer[] respQuserIdsIn, final ProgramVO programVOIn, final AppliedStrategyVO[] appliedStrategyVOsIn, final PmfmStrategyVO[] pmfmStrategyVOsIn)
    {
        this.stratId = stratIdIn;
        this.stratNm = stratNmIn;
        this.stratDc = stratDcIn;
        this.stratCreationDt = stratCreationDtIn;
        this.updateDt = updateDtIn;
        this.statusCd = statusCdIn;
        this.progCd = progCdIn;
        this.respDepIds = respDepIdsIn;
        this.respQuserIds = respQuserIdsIn;
        this.programVO = programVOIn;
        this.appliedStrategyVOs = appliedStrategyVOsIn;
        this.pmfmStrategyVOs = pmfmStrategyVOsIn;
    }

    /**
     * Copies constructor from other StrategyVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public StrategyVO(final StrategyVO otherBean)
    {
        this.stratId = otherBean.getStratId();
        this.stratNm = otherBean.getStratNm();
        this.stratDc = otherBean.getStratDc();
        this.stratCreationDt = otherBean.getStratCreationDt();
        this.updateDt = otherBean.getUpdateDt();
        this.statusCd = otherBean.getStatusCd();
        this.progCd = otherBean.getProgCd();
        this.respDepIds = otherBean.getRespDepIds();
        this.respQuserIds = otherBean.getRespQuserIds();
        this.programVO = otherBean.getProgramVO();
        this.appliedStrategyVOs = otherBean.getAppliedStrategyVOs();
        this.pmfmStrategyVOs = otherBean.getPmfmStrategyVOs();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final StrategyVO otherBean)
    {
        if (null != otherBean)
        {
            this.setStratId(otherBean.getStratId());
            this.setStratNm(otherBean.getStratNm());
            this.setStratDc(otherBean.getStratDc());
            this.setStratCreationDt(otherBean.getStratCreationDt());
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setStatusCd(otherBean.getStatusCd());
            this.setProgCd(otherBean.getProgCd());
            this.setRespDepIds(otherBean.getRespDepIds());
            this.setRespQuserIds(otherBean.getRespQuserIds());
            this.setProgramVO(otherBean.getProgramVO());
            this.setAppliedStrategyVOs(otherBean.getAppliedStrategyVOs());
            this.setPmfmStrategyVOs(otherBean.getPmfmStrategyVOs());
        }
    }

    /**
     * Identifiant interne de la stratégie
     * Get the stratId Attribute
     * @return stratId Integer
     */
    public Integer getStratId()
    {
        return this.stratId;
    }

    /**
     * Identifiant interne de la stratégie
     * @param value Integer
     */
    public void setStratId(final Integer value)
    {
        this.stratId = value;
    }

    /**
     * Libellé de la stratégie
     * Get the stratNm Attribute
     * @return stratNm String
     */
    public String getStratNm()
    {
        return this.stratNm;
    }

    /**
     * Libellé de la stratégie
     * @param value String
     */
    public void setStratNm(final String value)
    {
        this.stratNm = value;
    }

    /**
     * Description de la stratégie (de type commentaire car taille insuffisante)
     * Get the stratDc Attribute
     * @return stratDc String
     */
    public String getStratDc()
    {
        return this.stratDc;
    }

    /**
     * Description de la stratégie (de type commentaire car taille insuffisante)
     * @param value String
     */
    public void setStratDc(final String value)
    {
        this.stratDc = value;
    }

    /**
     * Date de création de l'objet
     * Get the stratCreationDt Attribute
     * @return stratCreationDt Date
     */
    public Date getStratCreationDt()
    {
        return this.stratCreationDt;
    }

    /**
     * Date de création de l'objet
     * @param value Date
     */
    public void setStratCreationDt(final Date value)
    {
        this.stratCreationDt = value;
    }

    /**
     * Date de mise à jour de l'objet
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de mise à jour de l'objet
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * TODO: Model Documentation for attribute statusCd
     * Get the statusCd Attribute
     * @return statusCd String
     */
    public String getStatusCd()
    {
        return this.statusCd;
    }

    /**
     * 
     * @param value String
     */
    public void setStatusCd(final String value)
    {
        this.statusCd = value;
    }

    /**
     * TODO: Model Documentation for attribute progCd
     * Get the progCd Attribute
     * @return progCd String
     */
    public String getProgCd()
    {
        return this.progCd;
    }

    /**
     * 
     * @param value String
     */
    public void setProgCd(final String value)
    {
        this.progCd = value;
    }

    /**
     * TODO: Model Documentation for attribute respDepIds
     * Get the respDepIds Attribute
     * @return respDepIds Integer[]
     */
    public Integer[] getRespDepIds()
    {
        return this.respDepIds;
    }

    /**
     * 
     * @param value Integer[]
     */
    public void setRespDepIds(final Integer[] value)
    {
        this.respDepIds = value;
    }

    /**
     * TODO: Model Documentation for attribute respQuserIds
     * Get the respQuserIds Attribute
     * @return respQuserIds Integer[]
     */
    public Integer[] getRespQuserIds()
    {
        return this.respQuserIds;
    }

    /**
     * 
     * @param value Integer[]
     */
    public void setRespQuserIds(final Integer[] value)
    {
        this.respQuserIds = value;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * Get the programVO Association
     * @return this.programVO ProgramVO
     */
    public ProgramVO getProgramVO()
    {
        return this.programVO;
    }

    /**
     * Sets the programVO
     * @param value ProgramVO
     */
    public void setProgramVO(ProgramVO value)
    {
        this.programVO = value;
    }

    /**
     * Identifie les conditions d'application locale de la stratégie pour une période donnée.
     * Get the appliedStrategyVOs Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.appliedStrategyVOs AppliedStrategyVO[]
     */
    public AppliedStrategyVO[] getAppliedStrategyVOs()
    {
        return this.appliedStrategyVOs;
    }

    /**
     * Sets the appliedStrategyVOs
     * @param value AppliedStrategyVO[]
     */
    public void setAppliedStrategyVOs(AppliedStrategyVO[] value)
    {
        this.appliedStrategyVOs = value;
    }

    /**
     * PSFM associés à une stratégie
     * PMSF associés à une stratégie.
     * Get the pmfmStrategyVOs Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.pmfmStrategyVOs PmfmStrategyVO[]
     */
    public PmfmStrategyVO[] getPmfmStrategyVOs()
    {
        return this.pmfmStrategyVOs;
    }

    /**
     * Sets the pmfmStrategyVOs
     * @param value PmfmStrategyVO[]
     */
    public void setPmfmStrategyVOs(PmfmStrategyVO[] value)
    {
        this.pmfmStrategyVOs = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        StrategyVO rhs = (StrategyVO) object;
        return new EqualsBuilder()
            .append(this.getStratId(), rhs.getStratId())
            .append(this.getStratNm(), rhs.getStratNm())
            .append(this.getStratDc(), rhs.getStratDc())
            .append(this.getStratCreationDt(), rhs.getStratCreationDt())
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getStatusCd(), rhs.getStatusCd())
            .append(this.getProgCd(), rhs.getProgCd())
            .append(this.getRespDepIds(), rhs.getRespDepIds())
            .append(this.getRespQuserIds(), rhs.getRespQuserIds())
            .append(this.getProgramVO(), rhs.getProgramVO())
            .append(this.getAppliedStrategyVOs(), rhs.getAppliedStrategyVOs())
            .append(this.getPmfmStrategyVOs(), rhs.getPmfmStrategyVOs())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final StrategyVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getStratId(), object.getStratId())
            .append(this.getStratNm(), object.getStratNm())
            .append(this.getStratDc(), object.getStratDc())
            .append(this.getStratCreationDt(), object.getStratCreationDt())
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getStatusCd(), object.getStatusCd())
            .append(this.getProgCd(), object.getProgCd())
            .append(this.getRespDepIds(), object.getRespDepIds())
            .append(this.getRespQuserIds(), object.getRespQuserIds())
            .append(this.getProgramVO(), object.getProgramVO())
            .append(this.getAppliedStrategyVOs(), object.getAppliedStrategyVOs())
            .append(this.getPmfmStrategyVOs(), object.getPmfmStrategyVOs())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getStratId())
            .append(this.getStratNm())
            .append(this.getStratDc())
            .append(this.getStratCreationDt())
            .append(this.getUpdateDt())
            .append(this.getStatusCd())
            .append(this.getProgCd())
            .append(this.getRespDepIds())
            .append(this.getRespQuserIds())
            .append(this.getProgramVO())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getAppliedStrategyVOs())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getPmfmStrategyVOs())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("stratId", this.getStratId())
            .append("stratNm", this.getStratNm())
            .append("stratDc", this.getStratDc())
            .append("stratCreationDt", this.getStratCreationDt())
            .append("updateDt", this.getUpdateDt())
            .append("statusCd", this.getStatusCd())
            .append("progCd", this.getProgCd())
            .append("respDepIds", this.getRespDepIds())
            .append("respQuserIds", this.getRespQuserIds())
            .append("programVO", this.getProgramVO())
            .append("appliedStrategyVOs", this.getAppliedStrategyVOs())
            .append("pmfmStrategyVOs", this.getPmfmStrategyVOs())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // StrategyVO value-object java merge-point
}